// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _ATKMM_COMPONENT_H
#define _ATKMM_COMPONENT_H

#include <glibmm.h>

/* $Id: component.hg,v 1.2 2003/03/22 21:30:40 murrayc Exp $ */

/* Copyright (C) 2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
extern "C"
{
  typedef struct _AtkComponentIface AtkComponentIface;
  typedef struct _AtkObject         AtkObject;
  typedef void (* AtkFocusHandler) (AtkObject*, gboolean);
}
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _AtkComponent AtkComponent;
typedef struct _AtkComponentClass AtkComponentClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Atk
{ class Component_Class; } // namespace Atk
namespace Atk
{


/** @addtogroup atkmmEnums Enums and Flags */

/**
 * @ingroup atkmmEnums
 */
enum CoordType
{
  XY_SCREEN,
  XY_WINDOW
};

} // namespace Atk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Atk::CoordType> : public Glib::Value_Enum<Atk::CoordType>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Atk
{

/**
 * @ingroup atkmmEnums
 */
enum Layer
{
  LAYER_INVALID,
  LAYER_BACKGROUND,
  LAYER_CANVAS,
  LAYER_WIDGET,
  LAYER_MDI,
  LAYER_POPUP,
  LAYER_OVERLAY,
  LAYER_WINDOW
};

} // namespace Atk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Atk::Layer> : public Glib::Value_Enum<Atk::Layer>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Atk
{


class Object;


class Component : public Glib::Interface
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Component CppObjectType;
  typedef Component_Class CppClassType;
  typedef AtkComponent BaseObjectType;
  typedef AtkComponentIface BaseClassType;

private:
  friend class Component_Class;
  static CppClassType component_class_;

  // noncopyable
  Component(const Component&);
  Component& operator=(const Component&);

protected:
  Component(); // you must derive from this class
  explicit Component(AtkComponent* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Component();

  static void add_interface(GType gtype_implementer);

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  AtkComponent*       gobj()       { return reinterpret_cast<AtkComponent*>(gobject_); }

  ///Provides access to the underlying C GObject.  
  const AtkComponent* gobj() const { return reinterpret_cast<AtkComponent*>(gobject_); }

private:


public:
  
  guint add_focus_handler(AtkFocusHandler handler);
  
  bool contains(int x, int y, CoordType coord_type) const;
  
  Glib::RefPtr<Atk::Object> get_accessible_at_point(int x, int y, CoordType coord_type);
  
  void get_extents(int& x, int& y, int& width, int& height, CoordType coord_type) const;
  
  void get_position(int& x, int& y, CoordType coord_type) const;
  
  void get_size(int& width, int& height) const;
#ifndef G_OS_WIN32

  
  Layer get_layer() const;
  
  int get_mdi_zorder() const;
#endif /* G_OS_WIN32 */

  
  bool grab_focus();
  
  void remove_focus_handler(guint handler_id);
  
  bool set_extents(int x, int y, int width, int height, CoordType coord_type);
  
  bool set_position(int x, int y, CoordType coord_type);
  
  bool set_size(int width, int height);

protected:
  
  
public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
  virtual guint add_focus_handler_vfunc(AtkFocusHandler handler);
  virtual bool contains_vfunc(int x, int y, CoordType coord_type);
  virtual Glib::RefPtr<Atk::Object> get_accessible_at_point_vfunc(int x, int y, CoordType coord_type);
  virtual void get_extents_vfunc(int& x, int& y, int& width, int& height, CoordType coord_type);
  virtual void get_position_vfunc(int& x, int& y, CoordType coord_type);
  virtual void get_size_vfunc(int& width, int& height);
  virtual Layer get_layer_vfunc();
  virtual int get_mdi_zorder_vfunc();
  virtual bool grab_focus_vfunc();
  virtual void remove_focus_handler_vfunc(guint handler_id);
  virtual bool set_extents_vfunc(int x, int y, int width, int height, CoordType coord_type);
  virtual bool set_position_vfunc(int x, int y, CoordType coord_type);
  virtual bool set_size_vfunc(int width, int height);

  //Default Signal Handlers::


};

} // namespace Atk


namespace Glib
{

/** @relates Atk::Component */
Glib::RefPtr<Atk::Component> wrap(AtkComponent* object, bool take_copy = false);

} // namespace Glib

#endif /* _ATKMM_COMPONENT_H */

