// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ACTION_H
#define _GTKMM_ACTION_H

#include <glibmm.h>

/* $Id: action.hg,v 1.1 2003/10/12 09:38:11 murrayc Exp $ */

/* Copyright (C) 2003 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>
#include <gtkmm/accelgroup.h>
#include <gtkmm/stockid.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkAction GtkAction;
typedef struct _GtkActionClass GtkActionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Action_Class; } // namespace Gtk
namespace Gtk
{


class Action : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef Action CppObjectType;
  typedef Action_Class CppClassType;
  typedef GtkAction BaseObjectType;
  typedef GtkActionClass BaseClassType;

private:
  friend class Action_Class;
  static CppClassType action_class_;

  // noncopyable
  Action(const Action&);
  Action& operator=(const Action&);

protected:
  explicit Action(const Glib::ConstructParams& construct_params);
  explicit Action(GtkAction* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~Action();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkAction*       gobj()       { return reinterpret_cast<GtkAction*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkAction* gobj() const { return reinterpret_cast<GtkAction*>(gobject_); }

  GtkAction* gobj_copy();

private:

  Action();
  explicit Action(const Glib::ustring& name, const StockID& stock_id, const Glib::ustring& label = Glib::ustring(), const Glib::ustring& tooltip = Glib::ustring());
public:
  
  static Glib::RefPtr<Action> create();


  //TODO: If the stock_id and the other arguments are mutually exclusive, then we should have create() and create_from_stock().
  
  static Glib::RefPtr<Action> create(const Glib::ustring& name, const Gtk::StockID& stock_id =  Gtk::StockID(), const Glib::ustring& label =  Glib::ustring(), const Glib::ustring& tooltip =  Glib::ustring());


  Glib::ustring name() const;
  
  void activate();
  
  Gtk::Widget* create_icon(IconSize icon_size);
  
  Gtk::Widget* create_menu_item();
  
  Gtk::Widget* create_tool_item();
  
  void connect_proxy(Widget& proxy);
  
  void disconnect_proxy(Widget& proxy);
  //TODO: _WRAP_METHOD(GSList*      gtk_action_get_proxies            ();
  
  void connect_accelerator();
  
  void disconnect_accelerator();

  /// For instance, void on_activate();
  typedef SigC::Slot0<void> SlotActivate;
  
  /**
   * @par Prototype:
   * <tt>void %activate()</tt>
   */
  Glib::SignalProxy0<void> signal_activate();

  //TODO: There are other signals, without default signal handlers.
   
protected:
  //For use by child actions:
  
  
  void block_activate_from(Widget& proxy);
  
  void unblock_activate_from(Widget& proxy);
  
  void set_accel_path(const Glib::ustring& accel_path);
  
  void set_accel_group(const Glib::RefPtr<AccelGroup>& accel_group);


  /* widget creation routines (not signals) */
  //gtkmmproc error: create_menu_item :  vfunc defs lookup failed
  //gtkmmproc error: create_tool_item :  vfunc defs lookup failed
  
              
public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):
  virtual void connect_proxy_vfunc(Widget* proxy);
  virtual void disconnect_proxy_vfunc(Widget* proxy);

  //Default Signal Handlers::
  virtual void on_activate();


};

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::Action */
  Glib::RefPtr<Gtk::Action> wrap(GtkAction* object, bool take_copy = false);
}


#endif /* _GTKMM_ACTION_H */

