// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_ENTRY_H
#define _GTKMM_ENTRY_H

#include <glibmm.h>

/* $Id: entry.hg,v 1.4 2003/10/12 09:38:11 murrayc Exp $ */

/* entry.h
 * 
 * Copyright (C) 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>
#include <gtkmm/editable.h>
#include <gtkmm/menu.h>
#include <gtkmm/celleditable.h>
#include <gtkmm/entrycompletion.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkEntry GtkEntry;
typedef struct _GtkEntryClass GtkEntryClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Entry_Class; } // namespace Gtk
namespace Gtk
{

/** A single line text entry field.
 *
 * The Gtk::Entry widget is a single line text entry widget. A fairly large
 * set of key bindings are supported by default. If the entered text is
 * longer than the allocation of the widget, the widget will scroll so that
 * the cursor position is visible. 
 *
 * @ingroup Widgets
 */

class Entry
: public Widget,
  public Editable,
  public CellEditable
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Entry CppObjectType;
  typedef Entry_Class CppClassType;
  typedef GtkEntry BaseObjectType;
  typedef GtkEntryClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Entry();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Entry_Class;
  static CppClassType entry_class_;

  // noncopyable
  Entry(const Entry&);
  Entry& operator=(const Entry&);

protected:
  explicit Entry(const Glib::ConstructParams& construct_params);
  explicit Entry(GtkEntry* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkEntry*       gobj()       { return reinterpret_cast<GtkEntry*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkEntry* gobj() const { return reinterpret_cast<GtkEntry*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_populate_popup(Menu* menu);
  virtual void on_insert_at_cursor(const Glib::ustring& str);
  virtual void on_activate();


private:

  
public:

  Entry();
  

  void set_visibility(bool visible = true);
  
  bool get_visibility() const;
  
  void set_invisible_char(gunichar ch);
  
  gunichar get_invisible_char() const;	
  
  void set_has_frame(bool setting = true);
  
  bool get_has_frame() const;
  
  void set_max_length(int max);
  
  int get_max_length() const;
  
  void set_activates_default(bool setting = true);
  
  gboolean get_activates_default() const;
  
  void set_width_chars(int n_chars);
  
  int get_width_chars() const;
  
  void set_text(const Glib::ustring &text);
  
  Glib::ustring get_text() const;
  
  Glib::RefPtr<Pango::Layout> get_layout();
  
  void get_layout_offsets(int& x, int& y);

  
  void set_completion(const Glib::RefPtr<EntryCompletion>& completion);
  
  Glib::RefPtr<EntryCompletion> get_completion();
  
  Glib::RefPtr<const EntryCompletion> get_completion() const;

  guint16 get_text_length() const;

  
  /**
   * @par Prototype:
   * <tt>void %populate_popup(Menu* menu)</tt>
   */
  Glib::SignalProxy1<void,Menu*> signal_populate_popup();

  
  /**
   * @par Prototype:
   * <tt>void %insert_at_cursor(const Glib::ustring& str)</tt>
   */
  Glib::SignalProxy1<void,const Glib::ustring&> signal_insert_at_cursor();


  //Key-binding signals:
  
  /**
   * @par Prototype:
   * <tt>void %activate()</tt>
   */
  Glib::SignalProxy0<void> signal_activate();
 //TODO: ignore this too? It's used in an example.
  
  
  Glib::PropertyProxy_ReadOnly<int> property_cursor_position();

  Glib::PropertyProxy_ReadOnly<int> property_selection_bound();

  Glib::PropertyProxy<bool> property_editable();

  Glib::PropertyProxy<int> property_max_length();

  Glib::PropertyProxy<bool> property_visibility();

  Glib::PropertyProxy<bool> property_has_frame();

  Glib::PropertyProxy<gunichar> property_invisible_char();

  Glib::PropertyProxy<bool> property_activates_default();

  Glib::PropertyProxy<int> property_width_chars();

  Glib::PropertyProxy_ReadOnly<int> property_scroll_offset();

  Glib::PropertyProxy<Glib::ustring> property_text();


};

} /* namespace Gtk */


namespace Glib
{
  /** @relates Gtk::Entry */
  Gtk::Entry* wrap(GtkEntry* object, bool take_copy = false);
}
#endif /* _GTKMM_ENTRY_H */

