// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_LABEL_H
#define _GTKMM_LABEL_H

#include <glibmm.h>

/* $Id: label.hg,v 1.2 2003/01/22 23:04:19 murrayc Exp $ */

/* Copyright(C) 1998-2002 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or(at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */


#include <gtkmm/misc.h>
#include <pangomm/attrlist.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkLabel GtkLabel;
typedef struct _GtkLabelClass GtkLabelClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class Label_Class; } // namespace Gtk
namespace Gtk
{

class Menu;

/** A widget that displays a small to medium amount of text.
 *
 * A simple setable widget for holding a Glib::ustring.
 * @ingroup Widgets
 */

class Label : public Misc
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Label CppObjectType;
  typedef Label_Class CppClassType;
  typedef GtkLabel BaseObjectType;
  typedef GtkLabelClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Label();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Label_Class;
  static CppClassType label_class_;

  // noncopyable
  Label(const Label&);
  Label& operator=(const Label&);

protected:
  explicit Label(const Glib::ConstructParams& construct_params);
  explicit Label(GtkLabel* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  GtkLabel*       gobj()       { return reinterpret_cast<GtkLabel*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const GtkLabel* gobj() const { return reinterpret_cast<GtkLabel*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_populate_popup(Menu* menu);


private:

  
public:
  Label();
  explicit Label(const Glib::ustring& label, bool mnemonic = false);

  /** This constructor is a shortcut for often used code
   * when you want to create a label with alignment different
   * than default one.
   * @code
   * Gtk::Label label(text, x, y, mnemonic);
   * @endcode
   * is equivalent to:
   * @code
   * Gtk::Label label(text, mnemonic);
   * label.set_alignment(x, y);
   * @endcode
   */
  Label(const Glib::ustring& label, float xalign, float yalign, bool mnemonic = false);

    /** This constructor is a shortcut for often used code
   * when you want to create a label with alignment different
   * than default one.
   * @code
   * Gtk::Label label(text, x, y, mnemonic);
   * @endcode
   * is equivalent to:
   * @code
   * Gtk::Label label(text, mnemonic);
   * label.set_alignment(x, y);
   * @endcode
   */
  Label(const Glib::ustring& label, AlignmentEnum xalign, AlignmentEnum yalign = ALIGN_CENTER, bool mnemonic = false);


  /// Doesn't use markup.
  
  void set_text(const Glib::ustring &str);
  
  Glib::ustring get_text() const;

  
  void set_attributes(Pango::AttrList& attrs);
  
  Pango::AttrList get_attributes() const;

  
  void set_label(const Glib::ustring& str);
  
  Glib::ustring get_label() const;
  
  void set_markup(const Glib::ustring& str);
  
  void set_use_markup(bool setting = true);
  
  bool get_use_markup() const;
  
  void set_use_underline(bool setting = true);
  
  bool get_use_underline() const;

  
  void set_markup_with_mnemonic(const Glib::ustring& str);
  
  guint get_mnemonic_keyval() const;
  
  void set_mnemonic_widget(Widget& widget);
  
  Widget* get_mnemonic_widget();
  
  const Widget* get_mnemonic_widget() const;
  
  void set_text_with_mnemonic(const Glib::ustring& str);
  
  void set_justify(Justification jtype);
  
  Justification get_justify() const;
  
  void set_pattern(const Glib::ustring& pattern);
  
  void set_line_wrap(bool wrap = true);
  
  bool get_line_wrap() const;
  
  void set_selectable(bool setting = true);
  
  bool get_selectable() const;
  
  void select_region(int start_offset, int end_offset);
  
  bool get_selection_bounds(int& start, int& end) const;

  
  Glib::RefPtr<Pango::Layout> get_layout();
  
  Glib::RefPtr<const Pango::Layout> get_layout() const;
  
  void get_layout_offsets(int& x, int& y) const;
  
  
  /**
   * @par Prototype:
   * <tt>void %populate_popup(Menu* menu)</tt>
   */
  Glib::SignalProxy1<void,Menu*> signal_populate_popup();


  //Keybinding signals:
  
  
  Glib::PropertyProxy<Glib::ustring> property_label();

  Glib::PropertyProxy<Pango::AttrList> property_attributes();

  Glib::PropertyProxy<bool> property_use_markup();

  Glib::PropertyProxy<bool> property_use_underline();

  Glib::PropertyProxy<Justification> property_justify();

  Glib::PropertyProxy_WriteOnly<Glib::ustring> property_pattern();

  Glib::PropertyProxy<bool> property_wrap();

  Glib::PropertyProxy<bool> property_selectable();

  Glib::PropertyProxy_ReadOnly<guint> property_mnemonic_keyval();

  Glib::PropertyProxy<Widget*> property_mnemonic_widget();

  Glib::PropertyProxy_ReadOnly<int> property_cursor_position();

  Glib::PropertyProxy_ReadOnly<int> property_selection_bound();


};

}  // namespace Gtk


namespace Glib
{
  /** @relates Gtk::Label */
  Gtk::Label* wrap(GtkLabel* object, bool take_copy = false);
}
#endif /* _GTKMM_LABEL_H */

