// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _GTKMM_UIMANAGER_H
#define _GTKMM_UIMANAGER_H

#include <glibmm.h>

/* $Id: uimanager.hg,v 1.2 2003/10/18 15:35:31 murrayc Exp $ */

/* Copyright (C) 2003 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/widget.h>
#include <gtkmm/action.h>
#include <gtkmm/actiongroup.h>
#include <gtkmm/uimanager.h>
 

#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _GtkUIManager GtkUIManager;
typedef struct _GtkUIManagerClass GtkUIManagerClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{ class UIManager_Class; } // namespace Gtk
namespace Gtk
{

/** @addtogroup gtkmmEnums Enums and Flags */

/**
 * @ingroup gtkmmEnums
 */
enum UIManagerItemType
{
  UI_MANAGER_AUTO,
  UI_MANAGER_MENUBAR,
  UI_MANAGER_MENU,
  UI_MANAGER_TOOLBAR,
  UI_MANAGER_PLACEHOLDER,
  UI_MANAGER_POPUP,
  UI_MANAGER_MENUITEM,
  UI_MANAGER_TOOLITEM,
  UI_MANAGER_SEPARATOR,
  UI_MANAGER_ACCELERATOR
};

} // namespace Gtk


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Gtk::UIManagerItemType> : public Glib::Value_Enum<Gtk::UIManagerItemType>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Gtk
{


class UIManager : public Glib::Object
{
  
#ifndef DOXYGEN_SHOULD_SKIP_THIS

public:
  typedef UIManager CppObjectType;
  typedef UIManager_Class CppClassType;
  typedef GtkUIManager BaseObjectType;
  typedef GtkUIManagerClass BaseClassType;

private:
  friend class UIManager_Class;
  static CppClassType uimanager_class_;

  // noncopyable
  UIManager(const UIManager&);
  UIManager& operator=(const UIManager&);

protected:
  explicit UIManager(const Glib::ConstructParams& construct_params);
  explicit UIManager(GtkUIManager* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
  virtual ~UIManager();

#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GObject.
  GtkUIManager*       gobj()       { return reinterpret_cast<GtkUIManager*>(gobject_); }

  ///Provides access to the underlying C GObject.
  const GtkUIManager* gobj() const { return reinterpret_cast<GtkUIManager*>(gobject_); }

  GtkUIManager* gobj_copy();

private:


  UIManager();
public:
  
  static Glib::RefPtr<UIManager> create();


  void set_add_tearoffs(bool add_tearoffs = true);
  
  bool get_add_tearoffs() const;
  
  void insert_action_group(const Glib::RefPtr<ActionGroup>& action_group, int pos = 0);
  
  void remove_action_group(const Glib::RefPtr<ActionGroup>& action_group);
  //TODO: const version:
  
  Glib::ListHandle< Glib::RefPtr<ActionGroup> > get_action_groups();
  
  Glib::RefPtr<AccelGroup> get_accel_group();
  
  Glib::RefPtr<const AccelGroup> get_accel_group() const;
  
  Widget* get_widget(const Glib::ustring& path);
  
  const Widget* get_widget(const Glib::ustring& path) const;  
  
  Glib::RefPtr<Action> get_action(const Glib::ustring& path);
  
  Glib::RefPtr<const Action> get_action(const Glib::ustring& path) const;
  
  guint add_ui_from_string(const Glib::ustring& buffer);
  
  guint add_ui_from_file(const Glib::ustring& filename);

//TODO: Is top=true a good default?
//TODO: typedef merge_id?
  
  void add_ui(guint merge_id, const Glib::ustring& path, const Glib::ustring& name, const Glib::ustring& action, UIManagerItemType type, bool top = true);
  
  void remove_ui(guint merge_id);
  
  Glib::ustring get_ui() const;
  
  void ensure_update();
  
  guint new_merge_id();


  /**
   * @par Prototype:
   * <tt>void %add_widget(Widget* widget)</tt>
   */
  Glib::SignalProxy1<void,Widget*> signal_add_widget();

  
  /**
   * @par Prototype:
   * <tt>void %actions_changed()</tt>
   */
  Glib::SignalProxy0<void> signal_actions_changed();


  Glib::PropertyProxy<bool> property_add_tearoffs();

  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_ui();

             
public:

public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::
  virtual void on_add_widget(Widget* widget);
  virtual void on_actions_changed();


};

} // namespace Gtk


namespace Glib
{
  /** @relates Gtk::UIManager */
  Glib::RefPtr<Gtk::UIManager> wrap(GtkUIManager* object, bool take_copy = false);
}


#endif /* _GTKMM_UIMANAGER_H */

